<?php
class shopBifitkassaPlugin extends shopPlugin
{
    const PLUGIN_ID = 'bifitkassa';
    const LOG_FILE_NAME = 'shop/plugins/bifitkassa/fiscalization.log';
    // создание запроса  на фискализацию чека
    public function processOrderStatus($params) {
        // параметры
        $log_ok	 		= $this->getSettings('log');
        $test 			= $this->getSettings('test') ? '-test' : '';
        $token = $test != '' ? 'P5cKbUUD9uSSrSlGdzspLblvBnD0GzTAE0cLmAPSEMxJ79DtLE' : $this->getSettings('token');
        if ($token != '')
        {
            // запускаем БИФИТ-процесс
            self::__mainProcess($params, $test, $token, $log_ok, 'front');
        }
        return 0;
    }
    function __mainProcess($params, $test, $token, $log_ok, $loc)
    {
        $action_id = ifset($params['action_id']);
        $order = $this->getOrder(ifset($params['order_id']));
        $payment_id = $order->params['payment_id'];
        $status_id		= $action_id;
        $pm_ids_data 		= $this->getSettings('pm_ids');
        $pm_ids = array();
        foreach ($pm_ids_data as $k=>$v) {
            $pm_ids[] = $v["payment_plugin_id"];
        }
        $pm_statuses 	= array_keys($this->getSettings('pm_statuses'));
        // Если совпадает способ оплаты и статус заказа
        if (isset($pm_ids) && isset($pm_statuses) && in_array($payment_id, $pm_ids) && in_array($status_id, $pm_statuses) && $token != '') {
            // 1. АВТОРИЗАЦИЯ
            //    процесс необходимый для подключения клиента к фискальному процессингу
            // адрес для POST-запроса
            $url = 'https://fp' . $test . '.bifit.com/processing-api/oauth/token';
            // данные ссылки
            $data = 'token=' . $token;
            $data .= '&client_id=processing-connector-token';
            $data .= '&client_secret=processing-connector-token';
            $data .= '&grant_type=token';
            // headers
            $headers = array('Content-Type: application/x-www-form-urlencoded');
            // декодируем полученный ответ
            $bifit = json_decode(self::__loadData($url, $headers, $data));
            // 2. ФОРМИРОВАНИЕ КОНТЕНТА ЧЕКА
            //    формирование информации для дальнейшей отправки на фискализацию
            // параметры плагина
            $cashier_name = $this->getSettings('cashier_name');
            $cashier_inn  = $this->getSettings('cashier_inn');
            $receipt_type = $this->getSettings('receipt_type');
            $tax_system   = $this->getSettings('tax_system');
            $calc_method  = $this->getSettings('calculation_method');
            //$vat_mode			= $this->getSettings('vat_mode');
            $vat             = $this->getSettings('vat');
            $payment_type    = $this->getSettings('payment_type');
            $payment_address = $this->getSettings('payment_address');
            $address_type    = $this->getSettings('payment_address');
            //$fio	 			= $this->getSettings('fio');
            // адрес клиента в чеке
            if ($address_type == 'phone' && $order->contact->get('phone', 'default')) {
                $address = self::__checkPhone($order->contact->get('phone', 'default'));
            } else {
                $address = self::__checkEmail($order->contact->get('email', 'default'));
            }
            // параметры массива
            $o_subtotal = 0;
            $r_products = array();
            $products   = $order->items;
            $o_shipment = $order->shipping;
            // массив товаров заказа
            foreach ($products as $key_id => $product) {
                //// корректируем цену товара с учётом скидок
                $p_price    = self::__formatprc(self::__checkProductPrice($product['price'],
                    ($order->total + $order->total), $order->discount, 0));
                $o_subtotal += $p_price * $product['quantity'];
                // очищаем имя товара от спец-символов
                $p_name = preg_replace('/[^\p{L}0-9 ]/iu', ' ', html_entity_decode($product['name']));
                $p_name = preg_replace('/ +/', ' ', trim($p_name));
                // формируем массив товаров для чека
                $r_products[$key_id]                     = new stdClass();
                $r_products[$key_id]->product_name       = $p_name;
                $r_products[$key_id]->product_item_price = $p_price;
                $r_products[$key_id]->product_quantity   = $product['quantity'];
                $r_products[$key_id]->product_tax        = 0;
            }
            // сверка итоговых сумм заказа и чека
            $total_1 = self::__formatprc($o_subtotal + $o_shipment);
            $total_2 = self::__formatprc($order->total);
            $diff    = $total_1 != $total_2 ? abs($total_1 - $total_2) : 0;
            // параметры для чека
            $items = '';
            // формируем данные чека
            foreach ($r_products as $key_id => $product) {
                // цена товара
                $p_price = $product->product_item_price;
                // изменение цены товара согласно сверки
                if ($diff > 0 && $p_price > $diff) {
                    $p_price = $total_2 > $total_1 ? $p_price + ($diff / $product->product_quantity) : $p_price - ($diff / $product->product_quantity);
                    $diff    = 0;
                }
                // выводим данные товара в чек
                $items .= $items != '' ? ', ' : '';
                $items .= '{';
                $items .= '"calculationMethod":"' . $calc_method . '", ';
                $items .= '"paymentSubject":"PRODUCT", ';
                $items .= '"name":"' . $product->product_name . '", ';
                $items .= '"price":' . self::__formatprc($p_price) . ', ';
                $items .= '"quantity":' . $product->product_quantity . ', ';
                //$items .= $vat_mode == 1 ? '"vat":"' . $vat . '", ' : '"vat":"VAT_' . floor($product->product_tax) . '", ';
                $items .= '"vat":"' . $vat . '", ';
                $items .= '"total":' . self::__formatprc($p_price * $product->product_quantity);
                $items .= '}';
            }
            // доставка
            if ($o_shipment > 0) {
                // выводим данные способа доставки в чек
                $items .= $items != '' ? ', ' : '';
                $items .= '{';
                $items .= '"calculationMethod":"' . $calc_method . '", ';
                $items .= '"paymentSubject":"SERVICE", ';
                $items .= '"name":"Доставка", ';
                $items .= '"price":' . self::__formatprc($o_shipment) . ', ';
                $items .= '"quantity":1, ';
                $items .= '"vat":"' . $vat . '", ';
                $items .= '"total":' . self::__formatprc($o_shipment);
                $items .= '}';
            }
            // формируем чек
            $receipt = '{';
            $receipt .= '"type":"' . $receipt_type . '", "taxSystem":"' . $tax_system . '", ';
            $receipt .= '"cashier":{';
            $receipt .= '"name":"' . $cashier_name . '"';
            $receipt .= $cashier_inn != '' ? ', "inn":"' . self::__checkInn($cashier_inn) . '"' : '';
            $receipt .= '}, ';
            $receipt .= '"client":{';
            $receipt .= '"address":"' . $address . '"';
            $receipt .= '}, ';
            $receipt .= '"paymentAddress":"' . $payment_address . '", ';
            $receipt .= '"items":[' . $items . '], ';
            $receipt .= '"total":' . self::__formatprc($order->total) . ', ';
            $receipt .= '"payments":{"' . $payment_type . '": ' . self::__formatprc($order->total) . '}';
            $receipt .= '}';
            // 3. ОТПРАВКА ЧЕКА В ФИСКАЛЬНЫЙ ПРОЦЕССИНГ
            //    передача контента чека в фискальный процессинг для дальнейшей фискализации
            // адрес для POST-запроса
            $url = 'https://fp' . $test . '.bifit.com/processing-api/protected/documents/registration/receipts';
            // данные чека
            $data = $receipt;
            // ключ идемпотентности (Idempotency-Key)
            $o_number  = $order->id;
            $o_summ    = self::__formatprc($order->total);
            $date_time = $order->create_datetime;
            $idemp_key = hash('sha256', "$o_number/$o_summ/$date_time");
            // headers
            $headers = array(
                'Content-Type: application/json',
                'Authorization: Bearer ' . $bifit->access_token,
                'Idempotency-Key: ' . $idemp_key
            );
            // получаем идентификатор документа на процессинге (id)
            $receipt_id = json_decode(self::__loadData($url, $headers, $data));
            // 4. ПОЛУЧЕНИЕ ДОКУМЕНТА ПО ID
            //    получение документа с фискальными признаками по его номеру
            // параметры
            $doc = '';
            if (!is_object($receipt_id)) {
                // ссылка для GET-запроса
                $url = 'https://fp' . $test . '.bifit.com/processing-api/protected/documents/' . $receipt_id;
                // headers
                $headers = array('Authorization: Bearer ' . $bifit->access_token);
                // получаем документ
                $doc = json_decode(self::__loadData($url, $headers, false));
            }
            // ССЫЛКА НА ЧЕК
            $receipt_link = 'https://fp' . $test . '.bifit.com/processing-api/receipts/' . $idemp_key;
            // ЛОГ ОПЕРАЦИИ
            // Если включено логирование
            if ($log_ok) {
                // параметры для лога
                $logObj               = new stdClass();
                $logObj->order_id     = $order->id;
                $logObj->order_number = $order->id;
                $logObj->order_date   = $order->create_datetime;
                $logObj->cashier      = $cashier_inn != '' ? $cashier_name . ', ИНН:' . self::__checkInn($cashier_inn) : $cashier_name;
                $logObj->client       = $address;
                $logObj->receipt_link = $receipt_link;
                $logObj->receipt_id   = !is_object($receipt_id) ? $receipt_id : '000';
                $logObj->receipt_type = $receipt_type;
                $logObj->payment_type = $payment_type;
                $logObj->doc          = '';
                $logObj->log          = '';
                // сохраняем лог операции
                self::__saveReport($test, $bifit, $receipt, $receipt_id, $doc, $loc, $logObj);
            }
            return $receipt_id;
        }
        return 0;
    }
    function __saveReport($test, $bifit, $receipt, $receipt_id, $doc, $loc, $logObj)
    {
        // выводим место и свойство операции
        $loc 	= $loc == 'admin' ? ' (админ)' : ' (фронт)';
        $log  	= '####### Боевой запрос' . $loc . "\n";
        $log  	= $test != '' ? '####### Тестовый запрос' . $loc . "\n" : $log;
        // устанавливаем часовой пояс согласно настройкам сайта
        $log   .= '####### ' . date('d-m-Y H:i:s', time()) . "\n";
        // ОТВЕТ #1
        $log   .= '####### Ответ #1: ' . "\n";
        // данные ответа #1
        if (is_object($bifit))
        {
            foreach ($bifit as $key=>$val)
            {
                $log .= $key . ': ' . $val . "\n";
            }
        }
        // ЧЕК
        // сформированный чек для отправки
        $log   .= '####### Чек: ' . "\n" . $receipt . "\n";
        // ОТВЕТ #2
        $log   .= '####### Ответ #2: ' . "\n";
        // данные ответа #2
        if (is_object($receipt_id))
        {
            foreach ($receipt_id as $key=>$val)
            {
                if (is_array($val))
                {
                    foreach ($val as $k1=>$v1)
                    {
                        if (is_object($val[$k1]))
                        {
                            foreach ($val[$k1] as $k2=>$v2)
                            {
                                $log .= $v2 != '' ? ' – ' . $k2 . ': ' . $v2 . "\n" : '';
                            }
                        }
                    }
                }
                else
                {
                    $log .= $val != '' ? $key . ': ' . $val . "\n" : '';
                }
            }
        }
        else
        {
            $log   .= $receipt_id . "\n";
        }
        // ОТВЕТ #3
        $log   .= '####### Ответ #3: ' . "\n";
        $a_3 	= '';
        // данные ответа #3
        if (is_object($doc))
        {
            foreach ($doc as $key=>$val)
            {
                if (is_object($val))
                {
                    foreach ($val as $k1=>$v1)
                    {
                        if (is_array($v1))
                        {
                            foreach ($v1 as $k2=>$v2)
                            {
                                if (is_object($v1[$k2]))
                                {
                                    $a_3 .= "\n";
                                    foreach ($v1[$k2] as $k3=>$v3)
                                    {
                                        $a_3 .= $v3 != '' ? '   - ' . $k3 . ': ' . $v3 . "\n" : '';
                                    }
                                }
                            }
                            $a_3 .= "\n";
                        }
                        elseif (is_object($v1))
                        {
                            foreach ($v1 as $k2=>$v2)
                            {
                                if (is_object($v2))
                                {
                                    foreach ($v2 as $k3=>$v3)
                                    {
                                        $a_3 .= $v3 != '' ? '   - ' . $k3 . ': ' . $v3 . "\n" : '';
                                    }
                                }
                                else
                                {
                                    $a_3 .= $v2 != '' ? '  - ' . $k2 . ': ' . $v2 . "\n" : '';
                                }
                            }
                        }
                        else
                        {
                            $a_3 .= $v1 != '' ? ' - ' . $k1 . ': ' . $v1 . "\n" : '';
                        }
                    }
                }
                else
                {
                    $a_3 .= $val != '' ? $key . ': ' . $val . "\n" : '';
                }
            }
        }

        $log   .= $a_3;

        // ССЫЛКА НА ЧЕК

        // сформированная ссылка на чек
        $log   .= '####### Ссылка на чек: ' . "\n" . $logObj->receipt_link;


        $this->writeLog($log);

        // СОХРАНЯЕМ В БД //ToDo

        // параметры объекта
        $logObj->doc = $a_3 != '' ? $a_3 : '';
        $logObj->log = $log;

        $log_model = new shopOrderLogModel();
        $log_model->add([
            'order_id' => $logObj->order_id,
            'action_id' => '',
            'contact_id' => null,
            'before_state_id' => "new",
            'after_state_id' => "new",
            'text' => 'Ссылка на чек: ' . "\n" . $logObj->receipt_link,
        ]);
    }

    function __formatprc($price)
    {
        $dec_count	= 2;

        // форматируем цену согласно настроек
        $price		= $dec_count < 0 ? round($price, $dec_count) : number_format($price, $dec_count, '.', '');

        return $price;
    }

    function __checkInn($inn)
    {
        // только цифры в количестве 10 или 12 шт.
        $inn 		= (!preg_match("/^\d{12}$/", $inn)) ? 'ИНН задан в неверном формате!' : $inn;

        return $inn;
    }

    function __checkPhone($tel)
    {
        // удаляем лишние символы
        $phone 		= str_replace(array('+', '(', ')', '-', ' '), '', trim($tel));

        // получаем первую цифру
        $first 		= substr($phone, "0", 1);

        // если номер из 10 цифр и первая цифра не 7, то добавляем 7
        $phone 		= strlen($phone)==10 && $first != 7 ? '7' . $phone : $phone;

        // окончательная проверка
        $phone 		= (!preg_match("/^[0-9]{11}+$/", $phone)) ? 'Телефон задан в неверном формате!' : $phone;

        return $phone;
    }

    function __checkEmail($email)
    {
        // проверка модели записи
        $email 		= (!preg_match("/^\+\d+$|^\S+@\S+$/", $email)) ? 'E-mail задан в неверном формате!' : $email;

        return $email;
    }

    function __checkProductPrice($item_price, $order_subtotal, $order_discount = 0, $order_payment = 0)
    {
        // если скидка больше нуля
        if ($order_discount > 0)
        {
            // вычисляем процент скидки
            $percent 	= $order_discount * 100 / $order_subtotal;

            // уменьшаем цену товара согласно скидки
            $item_price = $item_price - ($item_price * ($percent / 100));
        }

        // если система оплаты больше нуля
        if ($order_payment > 0)
        {
            // вычисляем процент наценки
            $percent 	= $order_payment * 100 / ($order_subtotal - $order_discount);

            // увеличиваем цену товара согласно наценки
            $item_price = $item_price + ($item_price * ($percent / 100));
        }

        return $item_price;
    }

    function __loadData($url, $headers = false, $data = false)
    {
        // инициализируем сеанс cURL
        $ch 	= curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);

        // добавляем данные
        if ($data)
        {
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        }

        // возврат результата в качестве строки
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

        // добавляем headers
        if ($headers)
        {
            curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        }

        // получаем ответ
        $output	= curl_exec($ch);

        // завершаем сеанс cURL
        curl_close($ch);

        return $output;
    }

    //добавление в файл лог записи
    public function writeLog($message) {
        if (is_string($message)) {
            waLog::log($message, self::LOG_FILE_NAME);
        } else {
            waLog::dump($message, self::LOG_FILE_NAME);
        }
    }

    /**
     * @param $order_id
     * @return shopOrder|false
     */
    private function getOrder($order_id)
    {
        try {
            $order = new shopOrder($order_id);
        } catch (Exception $e) {
            waLog::log('Order not found: ' . $order_id, self::LOG_FILE);

            return false;
        }

        return $order;
    }

    public function addressTypeValues() {

        $res =array(
            array(
                'value' => 'phone',
                'title' => 'Телефон',
            ),
            array(
                'value' => 'email',
                'title' => 'E-mail',
            )
        );

        return $res;
    }
    public function receiptTypeValues() {

        $res =array(
            array(
                'value' => 'SALE',
                'title' => 'Приход',
            ),
            array(
                'value' => 'SALE_RETURN',
                'title' => 'Возврат прихода',
            ),
            array(
                'value' => 'PURCHASE',
                'title' => 'Расход',
            ),
            array(
                'value' => 'PURCHASE_RETURN',
                'title' => 'Возврат расхода',
            ),
        );

        return $res;
    }
    public function taxSystemValues() {

        $res =array(
            array(
                'value' => 'COMMON',
                'title' => 'ОСН',
            ),
            array(
                'value' => 'SIMPLIFIED',
                'title' => 'УСН доход',
            ),
            array(
                'value' => 'SIMPLIFIED_WITH_EXPENS',
                'title' => 'УСН доход-расход',
            ),
            array(
                'value' => 'ENVD',
                'title' => 'ЕНВД',
            ),
            array(
                'value' => 'COMMON_AGRICULTURAL',
                'title' => 'ЕСХН',
            ),
            array(
                'value' => 'PATENT',
                'title' => 'ПАТЕНТ',
            ),
        );

        return $res;
    }

    public function calculationMethodValues() {

        $res =array(
            array(
                'value' => 'PREPAY_FULL',
                'title' => 'Полная предварительная оплата до момента передачи предмета расчёта',
            ),
            array(
                'value' => 'PREPAY_PARTIAL',
                'title' => 'Частичная предварительная оплата до момента передачи предмета расчёта',
            ),
            array(
                'value' => 'AVANS',
                'title' => 'Аванс',
            ),
            array(
                'value' => 'FULL_PAY',
                'title' => 'Полная оплата, в том числе с учётом аванса (предварительной оплаты) в момент передачи предмета расчёта',
            ),
            array(
                'value' => 'PARTIAL_SETTLEMENT_AND_CREDIT',
                'title' => 'Частичная оплата предмета расчёта в момент его передачи с последующей оплатой в кредит',
            ),
            array(
                'value' => 'TRANSFER_ON_CREDIT',
                'title' => 'Передача предмета расчёта без его оплаты в момент его передачи с последующей оплатой в кредит',
            ),
            array(
                'value' => 'CREDIT_PAYMENT',
                'title' => 'Оплата предмета расчёта после его передачи с оплатой в кредит (оплата кредита)',
            ),
        );

        return $res;
    }
    public function paymentTypeValues() {

        $res =array(
            array(
                'value' => 'CASH',
                'title' => 'Сумма оплаты наличными',
            ),
            array(
                'value' => 'CARD',
                'title' => 'Сумма оплата безналичными',
            ),
            array(
                'value' => 'PREPAY',
                'title' => 'Сумма оплаты предоплатой (зачётом аванса)',
            ),
            array(
                'value' => 'POSTPAY',
                'title' => 'Сумма оплаты постоплатой (в кредит)',
            ),
            array(
                'value' => 'OTHER',
                'title' => 'Сумма оплаты встречным предоставлением',
            ),
        );

        return $res;
    }
    public function vatValues() {

        $res =array(
            array(
                'value' => 'VAT_0',
                'title' => 'НДС 0%',
            ),
            array(
                'value' => 'VAT_10',
                'title' => 'НДС 10%',
            ),
            array(
                'value' => 'VAT_20',
                'title' => 'НДС 20%',
            ),
            array(
                'value' => 'VAT_110',
                'title' => 'НДС 10/110',
            ),
            array(
                'value' => 'VAT_120',
                'title' => 'НДС 20/120',
            ),
        );

        return $res;
    }


    /**
     * Возвращает список возможных действий для заказа
     *
     * @return array
     */
    public static function settingAvailableOrderActions()
    {
        $workflow = new shopWorkflow();
        $actions = $workflow->getAvailableActions();

        $data = [];
        foreach ($actions as $key => $action) {
            if (isset($action['state'])) {
                $data[] = [
                    'value' => $key,
                    'title' => $action['name']
                ];
            }
        }

        return $data;
    }


    public static function getPaymentTypes() {
        $plugin_id = self::PLUGIN_ID;
        $settings_name = 'pm_ids';
        $spm = new shopPluginModel();
        $methods = $spm->listPlugins('payment');
        $plugin = waSystem::getInstance()->getPlugin($plugin_id, true);
        $namespace = wa()->getApp().'_'.$plugin_id;
        $settings = $plugin->getSettings($settings_name);

        $row_tpl = '<tr><td>%s</td></tr>';
        $controls = <<<HTML
            <table class="zebra">
                <tr>
                    <th>Способ оплаты</th>
                  
                </tr>
HTML;

        foreach($methods as $k => $v) {
            $params = array(
                'namespace' => $namespace,
                'title_wrapper' => '&nbsp;%s',
                'description_wrapper' => '<span class="hint">%s</span>',
                'control_wrapper' => '%2$s'."\n".'%1$s'."\n".'%3$s'."\n",
            );

            waHtmlControl::addNamespace($params, array($settings_name, $v['id']));
            $payment_type = waHtmlControl::getControl(
                waHtmlControl::CHECKBOX,
                'payment_plugin_id',
                array_merge(
                    $params,
                    array(
                        'class' => 'pm_ids_class',
                        'checked' => isset($settings[$v['id']]),
                        'value' => $v['id'],
                        'title' => $v['name'],
                    )
                )
            );

            $controls .= sprintf($row_tpl, $payment_type);
        }

        $controls .= "</table><script type='text/javascript'>";
        $controls .= <<<JS
            $(function() {
                var enable_disable_select = function() {
                var _t = $(this);
                _t.parents('tr').find('select')
                .prop('disabled', !_t.is(':checked'));
            }
            $('input[type="checkbox"].pm_ids_class')
                .on('change', enable_disable_select)
                .each(enable_disable_select)
            });
JS;
        $controls .= '</script>';
        return $controls;
    }

}
